#pragma once
#include <list>
#include <vector>
#include <string>
#include "libs.h"
#include "gui.h"
#include "view.h"
#include "generic_system_view.h"

class SectorView : public GenericSystemView {
public:
  SectorView(void);
  virtual ~SectorView(void);
  virtual void Update(void);
  virtual void Draw3D(void);
  bool GetSelectedSystem(int* sector_x, int* sector_y, int* system_idx);
private:
  void DrawSector(int x, int y);
  void PutText(std::string& text);
  void OnClickSystemInfo(void);

  float m_zoom;
  int m_secx, m_secy;
  int m_selected;
  float m_px, m_py;
  float m_rot_x, m_rot_z;
  Gui::Label* m_infoLabel;
  Gui::ImageButton* m_zoomInButton;
  Gui::ImageButton* m_zoomOutButton;
  GLuint m_gluDiskDlist;
};


