#pragma once
#include "body.h"
#include "vector3.h"
#include "matrix4x4.h"
#include "sbre/sbre.h"

class ObjMesh;

class StaticRigidBody: public Body {
public:
  StaticRigidBody(void);
  virtual ~StaticRigidBody(void);
  void SetPosition(vector3d p);
  /* Not valid to do SetVelocity on these. They are for huge things like
   * space stations and will be static relative to their frame of reference.
   */
  void SetVelocity(vector3d v);
  vector3d GetPosition(void);
  void TransformToModelCoords(const Frame* camFrame);
  void TransformCameraTo(void);
  void ViewingRotation(void);
  void GetRotMatrix(matrix4x4d& m);
  virtual void SetFrame(Frame* f);

  void RenderSbreModel(const Frame* camFrame, int model, ObjParams* params);
protected:
  dGeomID m_geom;
};

