#pragma once
#include "libs.h"
#include "gui.h"
#include "view.h"
#include "star_system.h"

class SystemView: public View {
public:
  SystemView(void);
  virtual ~SystemView(void);
  virtual void Update(void);
  virtual void Draw3D(void);

private:
  void PutOrbit(StarSystem::SBody* b);
  void PutBody(StarSystem::SBody* b);
  void PutLabel(StarSystem::SBody* b);
  void ViewingTransformTo(StarSystem::SBody* b);
  void OnClickObject(StarSystem::SBody* b, const Gui::MouseButtonEvent* ev);
  void OnClickAccel(float step);
  void ResetViewpoint(void);

  StarSystem* m_system;
  StarSystem::SBody* m_selectedObject;
  float m_rot_x, m_rot_z;
  float m_zoom;
  double m_time;
  double m_timeStep;
  Gui::ImageButton* m_zoomInButton;
  Gui::ImageButton* m_zoomOutButton;
  Gui::Label* m_timePoint;
};

